var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Building with CMake</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Building with CMake</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"building-with-cmake\"></a></div>\n\
<p>The CMake tool is used to both to generate projects for your plug-ins and applications, and to build the plug-ins and applications from the projects it generated.</p>\n\
<p>Projects are generated by calling a CMake Generator. <a href=\'#!/url=./dev_help/SettingUpCMake/The-CMakeList-File.html\' title=\'\'>A <span class=\'code\'>CMakeLists.txt</span> file</a> in the plug-in or application directory provides information about the libraries, files, and source needed to generate the project.</p>\n\
<p>Projects are generated using</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake -H. -B&lt;build_directory&gt; -G &lt;generator&gt;\n\
</pre></div><p>The Maya devkit supports three generators:</p>\n\
<ul>\n\
<li><p><span class=\'code\'>Visual Studio 16 2019 Win64</span> for 64bit Windows</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake -H. -Bbuild -G &quot;Visual Studio 16 2019 Win64&quot;</pre></div></li>\n\
<li><p><span class=\'code\'>Unix Makefiles</span> for macOS and Linux</p>\n\
<p><span class=\'code\'>sh cmake -H. -Bbuild -G &quot;Unix Makefiles&quot;</span></p></li>\n\
<li><p><span class=\'code\'>Xcode</span> for macOS</p>\n\
<p><span class=\'code\'>sh cmake -H. -Bbuild -G Xcode</span></p></li>\n\
</ul>\n\
<p>The <span class=\'code\'>-B</span> flag is used to specify the project file target directory.</p>\n\
<p>For example, to generate an XCode project in the <span class=\'code\'>project</span> directory, use</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake -H. -Bproject -G Xcode\n\
</pre></div><p>After your project is generated, you can open the project in an IDE and build it from there, or you can use CMake with the <span class=\'code\'>--build</span> option to build the plug-in or application</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build &lt;build_directory&gt;\n\
</pre></div><p>For example, if you generated the project to the <span class=\'code\'>project</span> directory, use</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">cmake --build project/\n\
</pre></div><p>Your built application or plug-in will be located in the top level of your build directory if you generated your project using <span class=\'code\'>Unix Makefiles</span>. If you used the <span class=\'code\'>Xcode</span> or <span class=\'code\'>Visual Studio 16 2019 Win64</span> generator, your plug-in or application will be located under the build directory&#39;s <span class=\'code\'>Debug</span> subdirectory.</p>\n\
<blockquote>\n\
<p><strong>Note:</strong> Plug-ins built on different platforms will have different extensions. Plug-ins built on Windows will have the <span class=\'code\'>mll</span> extension. Plug-ins built on Linux will have the <span class=\'code\'>so</span> extension. Plug-ins built on macOS will have the <span class=\'code\'>bundle</span> extension.</p>\n\
</blockquote>\n\
<p>Standalone applications are run directly from the command line or from Windows Explorer.</p>\n\
<p>If you set <span class=\'code\'>MAYA_PLUG_IN_PATH</span> path in <span class=\'code\'>Maya.env</span> as described in <a href=\'#!/url=./dev_help/SettingUpCMake/Setting-up-your-build-environment.html\' title=\'\'>Setting Up Your Build Environment</a>, you can copy your plug-in to the <span class=\'code\'>MAYA_PLUG_IN_PATH</span> and it will be loaded automatically into Maya. You can also choose to not place your plug-in in <span class=\'code\'>MAYA_PLUG_IN_PATH</span> and instead <a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/%20Loading-Samples-Plug-ins-Into-Maya.html\' title=\'\'>load it manually</a>.</p>\n\
<blockquote>\n\
<p><strong>Important:</strong> Do not rebuild a plug-in that is already loaded into Maya. <a href=\'#!/url=./dev_help/LoadingAndUnloadingPlugins/Unloading-Plug-ins.html\' title=\'\'>Unload the plug-in</a> before you rebuild it.</p>\n\
</blockquote>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";