var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>What&#39;s New in the Maya 2022 devkit</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>What&#39;s New in the Maya 2022 devkit</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"whats-new-in-the-maya-2022-devkit\"></a></div>\n\
<p>{{toc}}</p>\n\
<div class=\'section\'><a id=\"changes-to-minimum-requirements\"></a><h2 id=\"changes-to-minimum-requirements\">Changes to minimum requirements</h2></div>\n\
<div class=\'section\'><a id=\"new-os-and-compiler-requirements\"></a><h3 id=\"new-os-and-compiler-requirements\">New OS and compiler requirements</h3></div>\n\
<p>The minimum Maya Linux version has been updated to CentOS 7.6.</p>\n\
<p>The devkit now requires gcc 9.3.1 and Visual Studio 2019.7</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"updated-required-libraries-list-for-maya-on-linux\"></a><h3 id=\"updated-required-libraries-list-for-maya-on-linux\">Updated required libraries list for Maya on Linux</h3></div>\n\
<p>The required Linux libraries has been updated.</p>\n\
<p>See <a href=\'#!/url=./dev_help/What-s-New-What-s-Changed-/topicid=GUID-D2B5433C-E0D2-421B-9BD8-24FED217FD7F/\' title=\'\'>Additional required Linux packages for Maya installation</a> for the complete list of required Linux libraries.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"python-3-support\"></a><h2 id=\"python-3-support\">Python 3 support</h2></div>\n\
<p>Maya 2022 for Linux and Windows now supports both Python 2 and Python 3. However, future versions of Maya will only support Python 3.</p>\n\
<p>Maya 2022 for macOS only supports Python 3.</p>\n\
<div class=\'section\'><a id=\"maya-starts-up-in-python-3-mode-by-default\"></a><h3 id=\"maya-starts-up-in-python-3-mode-by-default\">Maya starts up in Python 3 mode by default</h3></div>\n\
<blockquote>\n\
<p><strong>Note</strong>: Maya 2022 for Linux and Windows now supports both Python 2 and Python 3. However, future versions of Maya will only support Python 3.</p>\n\
<p>Maya 2022 for macOS only supports Python 3.</p>\n\
</blockquote>\n\
<p>Maya on Windows and Linux now start in Python 3 mode by default. However, if needed, it can still be started in Python 2 mode.</p>\n\
<p>To start Maya in Python 2 mode, start Maya from the command line with <span class=\'code\'>-pythonver 2</span>. For example, to start Maya on Windows in Python 2 mode, run <span class=\'code\'>maya.exe -pythonver 2</span> from a command window.</p>\n\
<p>Alternately, you can use the <span class=\'code\'>MAYA_PYTHON_VERSION</span> environment variable to set the Python mode.</p>\n\
<ol>\n\
<li>Open a command or terminal window</li>\n\
<li>Set the <span class=\'code\'>MAYA_PYTHON_VERSION</span> environment variable to 2</li>\n\
<li>Start Maya from the same command or terminal window.</li>\n\
</ol>\n\
<p>The Python mode specified in the Maya start up command will override the mode specified by <span class=\'code\'>MAYA_PYTHON_VERSION</span>.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"render.exe-and-render.sh-can-now-run-in-either-python-2-or-python-3-mode\"></a><h3 id=\"render.exe-and-render.sh-can-now-run-in-either-python-2-or-python-3-mode\">Render.exe and Render.sh can now run in either Python 2 or Python 3 mode</h3></div>\n\
<p>The <span class=\'code\'>pythonver</span> command line option has been added to the command line renderer on Windows and Linux. This lets users choose whether they want to run the command line renderer in either Python 2 or Python 3 mode.</p>\n\
<p>Use <span class=\'code\'>Render.exe -pythonver 2</span> on Windows or <span class=\'code\'>./Render -pythonver 2</span> to use Python 2.</p>\n\
<p>Use <span class=\'code\'>Render.exe -pythonver 3</span> on Windows or <span class=\'code\'>./Render -pythonver 3</span> to use Python 3.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-pip-support\"></a><h3 id=\"new-pip-support\">New pip support</h3></div>\n\
<p><span class=\'code\'>mayapy</span> now supports installing Python 3 modules with pip. To use pip with <span class=\'code\'>mayapy</span>, use the following commands:</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Linux</td>\n\
<td align=\"left\"><span class=\'code\'>./mayapy -m pip &lt;command&gt;</span></td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">macOS</td>\n\
<td align=\"left\"><span class=\'code\'>./mayapy -m pip &lt;command&gt;</span></td>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Windows</td>\n\
<td align=\"left\"><span class=\'code\'>mayapy -m pip &lt;command&gt;</span></td>\n\
</tr>\n\
</table>\n\
<p>See <a href=\'#!/url=./dev_help/What-s-New-What-s-Changed-/topicid=GUID-72A245EC-CDB4-46AB-BEE0-4BBBF9791627/\' title=\'\'>Managing Python packages with mayapy and pip</a> for more information.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"notable-changes-to-third-party-components\"></a><h2 id=\"notable-changes-to-third-party-components\">Notable changes to third party components</h2></div>\n\
<div class=\'section\'><a id=\"qt-and-pyside-have-been-updated-to-version-5.15.2\"></a><h3 id=\"qt-and-pyside-have-been-updated-to-version-5.15.2\">Qt and PySide have been updated to version 5.15.2</h3></div>\n\
<p>The versions of Qt and PySide used by Maya have been updated to version 5.15.2. Any code that uses an older version of Qt will need to be recompiled.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"updates-to-alembic-and-openexr-libraries\"></a><h3 id=\"updates-to-alembic-and-openexr-libraries\">Updates to Alembic and OpenEXR libraries</h3></div>\n\
<p>Updates have been made to the Alembic and OpenEXR libraries packaged with Maya. Minor security updates have been made to Alembic, and OpenEXR has been updated to version 2.4.1.</p>\n\
<p>Plug-ins that rely on these libraries will need to be recompiled.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"qt-creator-tools\"></a><h3 id=\"qt-creator-tools\">Qt Creator Tools</h3></div>\n\
<p>Qt Creator auxiliary tools will not be distributed in their entirety with Maya from this point forward.</p>\n\
<p>Qt Creator tools can be downloaded from the <a href=\'https://www.qt.io\' title=\'\' target=\'_blank\'>Qt website</a>.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"generating-python-code-from-ui-files\"></a><h3 id=\"generating-python-code-from-ui-files\">Generating Python code from ui files</h3></div>\n\
<p>Starting in PySide 5.14, the pysideuic module has been removed by QtC.</p>\n\
<p>Users should use:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-nocode\">uic -g python &lt;ui_file&gt; -o &lt;output_python_file&gt;\n\
</pre></div><p>to generate python code from their .ui files.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"the-maya-script-editor-now-fully-supports-unicode-characters\"></a><h2 id=\"the-maya-script-editor-now-fully-supports-unicode-characters\">The Maya Script Editor now fully supports Unicode characters</h2></div>\n\
<p>The Maya Script Editor now fully supports Unicode characters. Python scripts are now saved using UTF-8 encoding as prescribed by PEP-263, ensuring that file contents do not appear corrupted when reopened.</p>\n\
<p>If a script containing international characters needs to be read by the script editor in an earlier version of Maya that does not support UTF-8, a new option in the Maya Preferences menu lets you save files using the system encoding instead. Go to <strong>Preferences -&gt; Settings -&gt; Files/Projects</strong>, scroll down to <strong>Script Editor</strong> and select <strong>system encoding</strong> from the drop-down menu.</p>\n\
<p>The script editor now also correctly reads, and can optionally insert, magic comments indicating the encoding to use.</p>\n\
<div class=\'section\'><a id=\"new-environment-variables\"></a><h2 id=\"new-environment-variables\">New environment variables</h2></div>\n\
<p>Two new environment variables, <span class=\'code\'>MAYA_BATCH_STDOUT_LOGGING_LEVEL</span> and <span class=\'code\'>MAYA_BATCH_STDERR_LOGGING_LEVEL</span>, have been added to control what is output to stderr and stdout by scripts, commands, and API calls.</p>\n\
<p>Valid values for both variables are <span class=\'code\'>all</span>, <span class=\'code\'>info</span>, <span class=\'code\'>result</span>, <span class=\'code\'>warning</span>, <span class=\'code\'>error</span>, and <span class=\'code\'>none</span>.</p>\n\
<p><span class=\'code\'>MAYA_BATCH_STDOUT_LOGGING_LEVEL</span> defaults to none, and <span class=\'code\'>MAYA_BATCH_STDERR_LOGGING_LEVEL</span> defaults to all.</p>\n\
<p>See <a href=\'#!/url=./dev_help/What-s-New-What-s-Changed-/topicid=GUID-F7E518B1-ACE3-4F13-B5CA-C0CF021D3494/\' title=\'\'>Output stream variables</a></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"opting-out-of-analytics-when-starting-maya-in-batch-mode\"></a><h2 id=\"opting-out-of-analytics-when-starting-maya-in-batch-mode\">Opting out of analytics when starting Maya in batch mode</h2></div>\n\
<p>When starting Maya in batch mode, analytics will run by default. To opt out of analytics, set <span class=\'code\'>MAYA_DISABLE_ADP</span> to 1 before starting Maya.</p>\n\
<p>See <a href=\'#!/url=./dev_help/What-s-New-What-s-Changed-/topicid=GUID-FC154DF1-CC21-4DBF-9FAC-19FDE6DCBC9A/\' title=\'\'>General variables</a>.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"autoloadonce-option-added-to-packagecontent.xml\"></a><h2 id=\"autoloadonce-option-added-to-packagecontent.xml\">AutoLoadOnce option added to PackageContent.xml</h2></div>\n\
<p>A new option, <span class=\'code\'>AutoLoadOnce</span> has been added to the <span class=\'code\'>PackageContents.xml</span> file that is used when distributing plug-ins using the Autodesk App Store format. When set to <span class=\'code\'>True</span>, the plug-in will be autoloaded the first time Maya is started after it has been installed. However, if the plug-in&#39;s autoload option is unchecked in the plug-in manager, the plug-in will not be autoloaded on startup from that point on.</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">&lt;ComponentEntry ModuleName=&quot;./Contents/plug-ins/myNode.py&quot; AutoLoadOnce=&quot;True&quot; /&gt;\n\
</pre></div><p><a href=\'#!/url=./dev_help/Distributing-Maya-Plug-ins/DistributingViaTheAppStore.html\' title=\'\'>See the section on distributing applications through the Autodesk app store for more information.</a></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"api-changes\"></a><h2 id=\"api-changes\">API changes</h2></div>\n\
<div class=\'section\'><a id=\"new-smart-pointer\"></a><h3 id=\"new-smart-pointer\">New smart pointer</h3></div>\n\
<p>MSharedPtr&lt;&gt; has been added to Maya.</p>\n\
<p>MSharedPtr&lt;&gt; objects are used in the Maya API to make object ownership explicit. They must be used with the Maya APIs that use MSharedPtr&lt;&gt;. No other object ownership scheme may be mixed with usage of MSharedPtr&lt;&gt;.</p>\n\
<p>As with any other smart pointer, hold an MSharedPtr&lt;&gt; for any object you may want to reuse later. Maya will hold its own MSharedPtr&lt;&gt; for any objects it may use again later to prevent the objects from being destroyed and deallocated.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-validator-for-decimal-indicators\"></a><h3 id=\"new-validator-for-decimal-indicators\">New validator for decimal indicators</h3></div>\n\
<p>The <span class=\'code\'>MayaQclocaleDoubleValidator</span> was added to <span class=\'code\'>maya.internal.common.qt.doubleValidator</span> to accomodate locales where decimal values use commas instead of periods.</p>\n\
<p>This validator should be used instead of <span class=\'code\'>QDoubleValidator</span> when developing a user interface with PySide.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-class-in-openmayaanim-module\"></a><h3 id=\"new-class-in-openmayaanim-module\">New class in OpenMayaAnim module</h3></div>\n\
<p>MFalloffContext has been added to the OpenMayaAnim module.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-class-added-as-part-of-the-gpu-deformer-upgrades\"></a><h3 id=\"new-class-added-as-part-of-the-gpu-deformer-upgrades\">New class added as part of the GPU deformer upgrades</h3></div>\n\
<p>MFnFloatVectorArrayData has been added to provide access to MFloatVectorArray. This is part of the GPU deformers upgrade.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-class-and-methods-to-perform-mrenderitem-specific-evaluations\"></a><h3 id=\"new-class-and-methods-to-perform-mrenderitem-specific-evaluations\">New class and methods to perform MRenderItem-specific evaluations</h3></div>\n\
<p>MPxViewportComputeItem has been added to perform MRenderItem-specific evaluation. <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::addViewportComputeItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#aa0554ba67faea19d29ad794ccbbe307b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::addViewportComputeItem()</a></span> and <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MRenderItem::viewportComputeItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_render_item.html#a9737f09d5be3c9a7c2e6b6b46410805a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MRenderItem::viewportComputeItem()</a></span> have been added to associate MPxViewportComputeItem with an MRenderItem.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-syntax-for-python-iterators\"></a><h3 id=\"new-syntax-for-python-iterators\">New syntax for Python iterators</h3></div>\n\
<p>New iterator syntax has been added to both Python API 1.0 and 2.0.</p>\n\
<p>The existing syntax calls <span class=\'code\'>next</span> on the object: <span class=\'code\'>iterator.next()</span>.</p>\n\
<p>The newly-added syntax calls <span class=\'code\'>next</span> with the iterator as the parameter: <span class=\'code\'>next(iterator)</span>.</p>\n\
<p>The existing syntax has not been deprecated in the Maya Python APIs, and any plug-ins and applications that use the existing syntax do not need to be updated to use the new syntax.</p>\n\
<p>Examples that used the existing syntax have been updated to use the new syntax.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changed-behavior-for-mglobalsetactiveselectionlist\"></a><h3 id=\"changed-behavior-for-mglobalsetactiveselectionlist\">Changed behavior for MGlobal::setActiveSelectionList()</h3></div>\n\
<p>Calling <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::setActiveSelectionList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a33e6a7c8fa1c06fd64063bd08d4e4aef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a01f841b592826fcbc987829fa7687c5d&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::setActiveSelectionList()</a></span> with an empty selection list no longer clears the active selection list regardless of the <span class=\'code\'>ListAdjustment</span> parameter value.</p>\n\
<p>Now <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal::setActiveSelectionList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html#a33e6a7c8fa1c06fd64063bd08d4e4aef&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a01f841b592826fcbc987829fa7687c5d&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGlobal::setActiveSelectionList()</a></span> behaves as expected: when it is called with an empty selection list, it will delete the list if <span class=\'code\'>ListAdjustment</span> is set to <span class=\'code\'>kReplaceList</span>, otherwise it will do nothing.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"deprecated-method-and-changed-behavior-in-mcacheschema\"></a><h3 id=\"deprecated-method-and-changed-behavior-in-mcacheschema\">Deprecated method and changed behavior in MCacheSchema</h3></div>\n\
<p>The following changes have been made to the MCacheSchema class:</p>\n\
<p><span class=\'code\'>reset()</span> has been deprecated. It should be removed from any code that uses it.</p>\n\
<p><span class=\'code\'>attributes()</span> is now a range over MObject rather than MPlug. Any code that uses this method needs to be modified to reflect this change.</p>\n\
<p>For example, if the original code used:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">for (<a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> plug : schema.attributes())  \n\
    {\n\
      //...\n\
    }\n\
</pre></div><p>it must be changed to:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-cpp\">for (<a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> attribute : schema.attributes())\n\
    {\n\
      //...\n\
    }\n\
</pre></div><p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-mitgeometry-constructors\"></a><h3 id=\"changes-to-mitgeometry-constructors\">Changes to MItGeometry constructors</h3></div>\n\
<p>Two new constructors have been added:</p>\n\
<ul>\n\
<li><span class=\'code\'>MItGeometry()</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_geometry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItGeometry</a>( <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a>&amp; dataHandle, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp; componentTagExpression, bool readOnly, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus)</span></li>\n\
</ul>\n\
<p>The new non-empty constructor is used when iterating over a subset of the geometry specified by a componentTagExpression.</p>\n\
<p>The behavior of</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_geometry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItGeometry</a> (<a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> &amp;dataHandle, unsigned int groupId, bool readOnly, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus)</span></p>\n\
<p>has changed. Now when a groupID of 0 is passed to it, zero vertices are returned instead of all vertices. To return all vertices, pass the constructor a groupID of -1.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-mrenderitem\"></a><h3 id=\"changes-to-mrenderitem\">Changes to MRenderItem</h3></div>\n\
<p>Six methods have been added to MRenderItem.</p>\n\
<p>One method was added to set the primitive type of a RenderItem explicitly created by a plug-in:</p>\n\
<ul>\n\
<li><span class=\'code\'>void setPrimitive(<a href=\"javascript:void(0)\" data-symbol=\"MGeometry::Primitive\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_geometry.html#a08260379b97fd733e30ea92e891ede1e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGeometry::Primitive</a> primitive, int stride)</span></li>\n\
</ul>\n\
<p>Two new methods were added for the purpose of marking objects for display filtering:</p>\n\
<ul>\n\
<li><span class=\'code\'>MUint64 objectTypeExclusionFlag() const</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> setObjectTypeExclusionFlag(MUint64 flag)</span></li>\n\
</ul>\n\
<p><span class=\'code\'>setObjectTypeExclusionFlag()</span> sets a bit flag for display filtering based on object type. <span class=\'code\'>objectTypeExclusionFlag()</span> queries the bit flag.</p>\n\
<p>Three methods were added that use the new <a href=$12022-Whats-New-in-API.html#new-smart-pointer\' title=\'\'>MSharedPtr</a>:</p>\n\
<ul>\n\
<li><span class=\'code\'>void setCustomData (const <a href=\"javascript:void(0)\" data-symbol=\"MSharedPtr\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_shared_ptr.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSharedPtr</a>&lt; <a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> &gt; &amp;userData)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSharedPtr\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_shared_ptr.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSharedPtr</a>&lt; <a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> &gt;  getCustomData () const</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>  setShaderFromNode2 (const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp;shaderNode, const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;shapePath, LinkLostCallback linkLostCb=nullptr, const <a href=\"javascript:void(0)\" data-symbol=\"MSharedPtr\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_shared_ptr.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSharedPtr</a>&lt; <a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> &gt; &amp;linkLostUserData=nullptr, bool nonTextured=false)</span></li>\n\
</ul>\n\
<p>Three methods have been deprecated:</p>\n\
<ul>\n\
<li><span class=\'code\'>void setCustomData (<a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> *userData)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> * customData () const</span></li>\n\
<li><span class=\'code\'>bool setShaderFromNode (const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp;shaderNode, const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;shapePath, LinkLostCallback=NULL, <a href=\"javascript:void(0)\" data-symbol=\"MUserData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_user_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_user_data.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUserData</a> *linkLostUserData=NULL, bool nonTextured=false)</span></li>\n\
</ul>\n\
<blockquote>\n\
<p><strong>Note:</strong></p>\n\
<p>You will need to replace any instances of <span class=\'code\'>setShaderFromNode()</span> in your code with <span class=\'code\'>setShaderFromNode2()</span>.</p>\n\
</blockquote>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-attribute-and-method-added-to-mpxgeometryfilter\"></a><h3 id=\"new-attribute-and-method-added-to-mpxgeometryfilter\">New attribute and method added to MPxGeometryFilter</h3></div>\n\
<p>The <span class=\'code\'>componentTagExpression</span> attribute has been added to MPxGeometry filter in the OpenMayaAnim module.</p>\n\
<p>The following new method was also added to the class:</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnGeometryData::SubsetState\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_geometry_data.html#aeb73ba275c53495dbe5bdd665fef854b&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFnGeometryData::SubsetState</a> getGeometryIterator (<a href=\"javascript:void(0)\" data-symbol=\"MItGeometry\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_geometry.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_geometry.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItGeometry</a> &amp;iter, <a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a> &amp;block, <a href=\"javascript:void(0)\" data-symbol=\"MDataHandle\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_handle.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_handle.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataHandle</a> &amp;dataHandle, unsigned int multiIndex, bool readOnly=true, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=nullptr) const</span></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-interface-added-to-mrenderoverride-in-the-openmayarender-module\"></a><h3 id=\"new-interface-added-to-mrenderoverride-in-the-openmayarender-module\">New interface added to MRenderOverride in the OpenMayaRender module</h3></div>\n\
<p>The following interface was added to MRenderOverride to override the default Viewport 2.0 selection:</p>\n\
<p><span class=\'code\'>virtual bool MRenderOverride::select(const <a href=\"javascript:void(0)\" data-symbol=\"MFrameContext\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_frame_context.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFrameContext</a>&amp; frameContext, const <a href=\"javascript:void(0)\" data-symbol=\"MSelectionInfo\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_selection_info.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_selection_info.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionInfo</a>&amp; selectInfo, bool useDepth, <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MSelectionList</a>&amp; selectionList, <a href=\"javascript:void(0)\" data-symbol=\"MPointArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_point_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_point_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPointArray</a>&amp; worldSpaceHitPts)</span></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mselectioninfo-in-the-openmayarender-module\"></a><h3 id=\"new-methods-added-to-mselectioninfo-in-the-openmayarender-module\">New methods added to MSelectionInfo in the OpenMayaRender module</h3></div>\n\
<p>The following methods were added to MSelectionInfo:</p>\n\
<ul>\n\
<li><span class=\'code\'>bool pointSnapping(<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>* ReturnStatus = nullptr) const;</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> cursorPoint(int&amp; x, int&amp; y) const;</span></li>\n\
</ul>\n\
<p><span class=\'code\'>pointSnapping()</span> determines whether the Viewport 2.0 selection is launched to find snap points, and <span class=\'code\'>cursorPoint()</span> queries the cursor point relative the lower left corner of the viewport.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-and-types-added-to-mfngeometrydata-to-support-component-tags\"></a><h3 id=\"new-methods-and-types-added-to-mfngeometrydata-to-support-component-tags\">New methods and types added to MFnGeometryData to support component tags</h3></div>\n\
<ul>\n\
<li><span class=\'code\'>enum ComponentTagCategory</span></li>\n\
<li><span class=\'code\'>enum SubsetState</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> componentTags (<a href=\"javascript:void(0)\" data-symbol=\"MStringArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStringArray</a> &amp;keys) const</span></li>\n\
<li><span class=\'code\'>bool hasComponentTag (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> addComponentTag (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> removeComponentTag (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> renameComponentTag (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;newKey)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> componentTagContents (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> setComponentTagContents (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp;component)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFn::Type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::Type</a> componentTagType (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'>ComponentTagCategory componentTagCategory (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;key, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'>unsigned int objectGroupCount ( <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>* ReturnStatus = NULL)</span></li>\n\
<li><span class=\'code\'>SubsetState  objectGroupSubsetState (unsigned int, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> resolveComponentTagExpression (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;expression, ComponentTagCategory ctg=MFnGeometryData::ComponentTagCategory::kAuto, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
<li><span class=\'code\'>SubsetState componentTagExpressionSubsetState (const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> &amp;expression, ComponentTagCategory ctg=MFnGeometryData::ComponentTagCategory::kAuto, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> *ReturnStatus=NULL) const</span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-and-types-added-to-mitdependencygraph\"></a><h3 id=\"new-methods-and-types-added-to-mitdependencygraph\">New methods and types added to MItDependencyGraph</h3></div>\n\
<p>Several new methods and types have been added to MItDependencyGraph to allow for traversing on graphs based on different relations. Whereas previously it only followed &quot;affects&quot; relationships, it can now traverse dependencies, traverse dependency graph connections, or traverse the evaluation graph.</p>\n\
<p>New type:</p>\n\
<p><span class=\'code\'>enum <a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph::Relationship\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html#a9d625fe894d9313ec78df1d78553f32e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDependencyGraph::Relationship</a></span></p>\n\
<p>New constructors:</p>\n\
<ul>\n\
<li><span class=\'code\'>MItDependencyGraph::MItDependencyGraph ( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp; rootNode, <a href=\"javascript:void(0)\" data-symbol=\"MFn::Type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::Type</a> filter = <a href=\"javascript:void(0)\" data-symbol=\"MFn::kInvalid\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a94dd08feda7b2cf0ff8262312c4fcc09&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kInvalid</a>, Direction direction = kDownstream, Traversal traversal = kDepthFirst, Level level = kNodeLevel, Relationship relationship = kDependsOn, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL )</span></li>\n\
<li><span class=\'code\'>MItDependencyGraph::MItDependencyGraph ( <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp; rootPlug, <a href=\"javascript:void(0)\" data-symbol=\"MFn::Type\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::Type</a> filter = <a href=\"javascript:void(0)\" data-symbol=\"MFn::kInvalid\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html#a1d1cfd8ffb84e947f82999c682b666a7a94dd08feda7b2cf0ff8262312c4fcc09&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MFn::kInvalid</a>, Direction direction = kDownstream, Traversal traversal = kDepthFirst, Level level = kPlugLevel, Relationship relationship = kDependsOn, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL )</span></li>\n\
<li><span class=\'code\'>MItDependencyGraph::MItDependencyGraph ( <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp; rootNode, <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp; rootPlug, <a href=\"javascript:void(0)\" data-symbol=\"MIteratorType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_iterator_type.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_iterator_type.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MIteratorType</a> &amp; infoObject,Direction direction = kDownstream, Traversal traversal = kDepthFirst, Level level = kNodeLevel, Relationship relationship = kDependsOn, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL )</span></li>\n\
</ul>\n\
<p>New methods:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph::Relationship\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html#a9d625fe894d9313ec78df1d78553f32e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDependencyGraph::Relationship</a> MItDependencyGraph::currentRelationship( <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL )</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> MItDependencyGraph::setCurrentRelationship( <a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph::Relationship\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html#a9d625fe894d9313ec78df1d78553f32e&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MItDependencyGraph::Relationship</a> relationship )</span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mfragmentmanager\"></a><h3 id=\"new-methods-added-to-mfragmentmanager\">New methods added to MFragmentManager</h3></div>\n\
<p>Two new methods were added to MFragmentManager to add and remove, respectively, a specific shader stage&#39;s input parameters.</p>\n\
<ul>\n\
<li><span class=\'code\'>bool addAutomaticShaderStageInput(ShaderStage shaderStage, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; parameterName, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; semantic, <a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance::ParameterType\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_instance.html#a4d63980e4031b0fc366e623868b27ed0&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance::ParameterType</a> parameterType, bool isVaryingInput);</span></li>\n\
<li><span class=\'code\'>bool removeAutomaticShaderStageInput(ShaderStage shaderStage, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; parameterName);</span></li>\n\
</ul>\n\
<p>Three new methods were added to manage the mapping between parameter names and transient names.</p>\n\
<ul>\n\
<li><span class=\'code\'>bool addDomainShaderInputNameMapping(const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; realParamName, const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; domainParamName);</span></li>\n\
<li><span class=\'code\'>bool removeDomainShaderInputNameMapping(const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; realParamName);</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a> findDomainShaderInputName(const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; realParamName);</span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-method-added-to-mselectionlist\"></a><h3 id=\"new-method-added-to-mselectionlist\">New method added to MSelectionList</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> getPlug ( unsigned int index, bool convertComponents, <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp;plug ) const</span> has been added to MSelectionList. <span class=\'code\'>convertComponents</span> controls whether selected components are converted to their equivalent plug when possible.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-method-added-to-mdgmodifier\"></a><h3 id=\"new-method-added-to-mdgmodifier\">New method added to MDGModifier</h3></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> deleteNode( const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> &amp; node, bool includeParents )</span> has been added to MDGModifier. This method exposes a boolean parameter that controls whether a DAG node&#39;s parents will be considered for deletion when it is deleted.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mpxgpudeformer\"></a><h3 id=\"new-methods-added-to-mpxgpudeformer\">New methods added to MPxGPUDeformer</h3></div>\n\
<p>Two new methods have been added to MPxGPUDeformer:</p>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> getFixedSetupData( const <a href=\"javascript:void(0)\" data-symbol=\"MString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MString</a>&amp; name )</span></li>\n\
<li><span class=\'code\'>static bool hasPlugBeenModified( const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp;plug )</span></li>\n\
</ul>\n\
<p><span class=\'code\'>getFixedSetupData()</span> facilitates sharing of setup data between the CPU and GPU versions of the deformer node.</p>\n\
<p><span class=\'code\'>hadPlugBeenModified()</span> indicates whether a plug has been changed since the last call to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGPUDeformer::evaluate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_g_p_u_deformer.html#a070259639bc552fd702c9e8e042f0331&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGPUDeformer::evaluate()</a></span>.</p>\n\
<p>The offsetNode example has been updated to use <span class=\'code\'>getFixedSetupData()</span> .</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-method-added-to-mfnnurbscurve\"></a><h3 id=\"new-method-added-to-mfnnurbscurve\">New method added to MFnNurbsCurve</h3></div>\n\
<p>A new method has been added to MFnNurbsCurve:</p>\n\
<p><span class=\'code\'>double findParamFromLength( double partLength, double tolerance, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL ) const</span></p>\n\
<p>This method is identical to the two parameter <span class=\'code\'>findParamFromLength()</span> method, but adds a tolerance parameter to control the search precision.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mevaluationnode\"></a><h3 id=\"new-methods-added-to-mevaluationnode\">New methods added to MEvaluationNode</h3></div>\n\
<p>Two new methods have been added to MEvaluationNode:</p>\n\
<ul>\n\
<li><span class=\'code\'>void skipEvaluation(const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; attribute, bool allowSingleDownstreamDependency = false, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>* ReturnStatus = nullptr) const</span></li>\n\
<li><span class=\'code\'>bool skippingEvaluation(const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a>&amp; attribute, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a>* ReturnStatus = nullptr) const</span></li>\n\
</ul>\n\
<p><span class=\'code\'>skipEvaluation()</span> tries to mark an attribute as skippable so that it is not evaluated by the Evaluation Engine. <span class=\'code\'>skippingEvaluation()</span> returns true if an attribute is marked as skippable.</p>\n\
<p>A new example, simpleSkipNode, has been added to demonstrate the use of these new methods.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mpxcustomevaluator\"></a><h3 id=\"new-methods-added-to-mpxcustomevaluator\">New methods added to MPxCustomEvaluator</h3></div>\n\
<p>Two new methods have been added to MPxCustomEvaluator:</p>\n\
<ul>\n\
<li><span class=\'code\'>bool MPxCustomEvaluator::wantPruneExecution ( ) const</span></li>\n\
<li><span class=\'code\'>bool MPxCustomEvaluator::pruneExecution ( const <a href=\"javascript:void(0)\" data-symbol=\"MCustomEvaluatorClusterNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_custom_evaluator_cluster_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MCustomEvaluatorClusterNode</a> * cluster ) virtual</span></li>\n\
</ul>\n\
<p>A new example, evaluationPruningEvaluator, has been added to demonstrate the use of these new methods.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-methods-added-to-mgpudeformerregistrationinfo\"></a><h3 id=\"new-methods-added-to-mgpudeformerregistrationinfo\">New methods added to MGPUDeformerRegistrationInfo</h3></div>\n\
<p>Four new methods have been added to MGPUDeformerRegistrationInfo:</p>\n\
<ul>\n\
<li><span class=\'code\'>void inputMeshAttributes(MOjbectArray&amp; inputAttributes)</span></li>\n\
<li><span class=\'code\'>bool matchAncestorLogicalIndices(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; original, <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; target)</span></li>\n\
<li><span class=\'code\'>virtual const <a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> passTrhoughInputMeshAttribute()</span></li>\n\
<li><span class=\'code\'>virtual bool matchAncestorLogicalIndices (const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp;original, <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp;target)</span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-mgpudeformerbuffer\"></a><h3 id=\"changes-to-mgpudeformerbuffer\">Changes to MGPUDeformerBuffer</h3></div>\n\
<p>Two new methods added to MGPUDeformerBuffer:</p>\n\
<ul>\n\
<li><span class=\'code\'>const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> plug()</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MOpenCLBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_open_c_l_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MOpenCLBuffer</a> createMOpenCLBuffer()</span></li>\n\
</ul>\n\
<p>And the signature for <span class=\'code\'>MGPUDeformerBuffer()</span> has been changed from</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerBuffer</a>(const <a href=\"javascript:void(0)\" data-symbol=\"MUniqueString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_unique_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniqueString</a>&amp; name, bool readOnly, unsigned int elementSizeInBytes, unsigned int elementCount, unsigned int capacityInBytes, const <a href=\"javascript:void(0)\" data-symbol=\"MAutoCLMem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_auto_c_l_mem.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MAutoCLMem</a>&amp; buffer, const <a href=\"javascript:void(0)\" data-symbol=\"MAutoCLEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_auto_c_l_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MAutoCLEvent</a>&amp; event);</span></p>\n\
<p>to</p>\n\
<p><span class=\'code\'>MGPUDeformerBuffer::MGPUDeformerBuffer(const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug, const <a href=\"javascript:void(0)\" data-symbol=\"MUniqueString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_unique_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniqueString</a>&amp; name, bool readOnly, unsigned int elementSizeInBytes, unsigned int elementCount, unsigned int capacityInBytes, const <a href=\"javascript:void(0)\" data-symbol=\"MAutoCLMem\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_auto_c_l_mem.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MAutoCLMem</a>&amp; buffer, const <a href=\"javascript:void(0)\" data-symbol=\"MAutoCLEvent\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_auto_c_l_event.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MAutoCLEvent</a>&amp; event);</span></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"signature-changes-in-mgpudeformerdata-and-mpxgpudeformer-classes\"></a><h3 id=\"signature-changes-in-mgpudeformerdata-and-mpxgpudeformer-classes\">Signature changes in MGPUDeformerData and MPxGPUDeformer classes</h3></div>\n\
<p>The signature for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerData::getBuffer()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_data.html#a5ce2553c6e11160092fa5f97721f0262&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerData::getBuffer()</a></span> has changed from</p>\n\
<p><span class=\'code\'>virtual <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerBuffer</a> MGPUDeformerData::getBuffer (const <a href=\"javascript:void(0)\" data-symbol=\"MUniqueString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_unique_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniqueString</a> &amp;name) const</span></p>\n\
<p>to</p>\n\
<p><span class=\'code\'>virtual <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerBuffer\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_buffer.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerBuffer</a> MGPUDeformerData::getBuffer(const <a href=\"javascript:void(0)\" data-symbol=\"MUniqueString\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_unique_string.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MUniqueString</a>&amp; name, const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; plug) const</span></p>\n\
<p>The signature for <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGPUDeformer::evaluate()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_g_p_u_deformer.html#a070259639bc552fd702c9e8e042f0331&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGPUDeformer::evaluate()</a></span> changed from</p>\n\
<p><span class=\'code\'>virtual DeformerStatus  evaluate (<a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a> &amp;block, const <a href=\"javascript:void(0)\" data-symbol=\"MEvaluationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_evaluation_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MEvaluationNode</a> &amp;evaluationNode, const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a> &amp;outputPlug, const <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerData</a> &amp;inputData, <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerData</a> &amp;outputData)</span></p>\n\
<p>to</p>\n\
<p><span class=\'code\'>virtual DeformerStatus evaluate(<a href=\"javascript:void(0)\" data-symbol=\"MDataBlock\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_data_block.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_data_block.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDataBlock</a>&amp; block, const <a href=\"javascript:void(0)\" data-symbol=\"MEvaluationNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_evaluation_node.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MEvaluationNode</a>&amp; evaluationNode, const <a href=\"javascript:void(0)\" data-symbol=\"MPlug\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlug</a>&amp; outputPlug, const <a href=\"javascript:void(0)\" data-symbol=\"MPlugArray\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_plug_array.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_plug_array.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPlugArray</a>&amp; inputPlugs, const <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerData</a>&amp; inputData, <a href=\"javascript:void(0)\" data-symbol=\"MGPUDeformerData\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_g_p_u_deformer_data.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MGPUDeformerData</a>&amp; outputData)</span></p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-argument-added-to-mpxcommand.setresult\"></a><h3 id=\"new-argument-added-to-mpxcommand.setresult\">New argument added to MPxCommand.setResult</h3></div>\n\
<p>A new argument, <span class=\'code\'>append</span>, has been added to <span class=\'code\'>MPxCommand.setResult</span> in Python API 2.0. When set to <span class=\'code\'>False</span>, <span class=\'code\'>setResult</span> returns a single value instead of a list.</p>\n\
<p>To maintain backward compatibility, <span class=\'code\'>append</span> is set to <span class=\'code\'>True</span> by default.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"other-new-methods\"></a><h3 id=\"other-new-methods\">Other new methods</h3></div>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> MDagPath::matchTransform (const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;source, const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;target, const <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;relative, <a href=\"javascript:void(0)\" data-symbol=\"MTransformationMatrix\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_transformation_matrix.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_transformation_matrix.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MTransformationMatrix</a> &amp;transformationMatrix, bool preserveOffsetParentMatrix=true, bool preservePivot=true, bool preservePivotOffset=false)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MCallbackId\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_callback_id.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MCallbackId</a> MDagMessage::addMatrixModifiedCallback(<a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagPath</a> &amp;affectedNode, <a href=\"javascript:void(0)\" data-symbol=\"MDagMessage::MWorldMatrixModifiedFunction\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_message.html#a58eba9ca14e2b727b62e966078364f00&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MDagMessage::MWorldMatrixModifiedFunction</a> func, void * clientData ,<a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus)</span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MObject</a> MFnGeometryFilter::getComponentAtIndex   (unsigned int index, <a href=\"javascript:void(0)\" data-symbol=\"MStatus\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_status.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MStatus</a> * ReturnStatus = NULL)</span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"other-deprecated-methods\"></a><h3 id=\"other-deprecated-methods\">Other deprecated methods</h3></div>\n\
<ul>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MCacheSchema::reset()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_cache_schema.html#ad20897c5c8bd47f5d4005989bead0e55&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MCacheSchema::reset()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadUtils::syncNumOpenMPThreads()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_utils.html#ab857568ad1f4a49da93939d7db7c2a1c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadUtils::syncNumOpenMPThreads()</a></span></li>\n\
<li><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxShaderOverride::initialize()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_px_shader_override.html#a0212be7dfc693d9d7a0f95ddcb81ba8d&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_px_shader_override.html#a8b9111ad0571d7b9624c05ca7cedb0b7&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxShaderOverride::initialize()</a></span></li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changes-to-devkit-examples\"></a><h2 id=\"changes-to-devkit-examples\">Changes to devkit examples</h2></div>\n\
<div class=\'section\'><a id=\"new-node-ids-for-several-examples\"></a><h3 id=\"new-node-ids-for-several-examples\">New node IDs for several examples</h3></div>\n\
<p>The node IDs (<span class=\'code\'>MTypeID</span>) of many examples have changed.</p>\n\
<p>These changes were made to ensure that the node IDs used in all examples were unique.</p>\n\
<p>However, any scene created using an example with a changed node ID will no longer open. You will need to recompile the example and recreate the scene.</p>\n\
<p>If you will be using an example in production, request a unique ID from <a href=\'http://mayaid.autodesk.io/\' title=\'\' target=\'_blank\'>http://mayaid.autodesk.io/</a> and use the provided node ID in the example before compiling.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"python-examples-have-been-moved-and-renamed\"></a><h3 id=\"python-examples-have-been-moved-and-renamed\">Python examples have been moved and renamed</h3></div>\n\
<p>Python API 1.0 examples have been renamed to have the <span class=\'code\'>py1</span> prefix, and Python API 2.0 examples have been renamed to have the <span class=\'code\'>py2</span> prefix.</p>\n\
<p>Python examples have also been moved from the <span class=\'code\'>scripting</span> directory to the <span class=\'code\'>python</span> directory.</p>\n\
<table class=\'ruled\'>\n\
<tr class=\"header\">\n\
<th align=\"left\">Platform</th>\n\
<th align=\"left\">Python API 1.0</th>\n\
<th align=\"left\">Python API 2.0</th>\n\
<th align=\"left\">Python standalone applications</th>\n\
</tr>\n\
<tr class=\"odd\">\n\
<td align=\"left\">Windows</td>\n\
<td align=\"left\">devkit\\plug-ins\\python\\api1</td>\n\
<td align=\"left\">devkit\\plug-ins\\python\\api2</td>\n\
<td align=\"left\">devkit\\applications\\python </td>\n\
</tr>\n\
<tr class=\"even\">\n\
<td align=\"left\">macOS and Linux</td>\n\
<td align=\"left\">devkit/plug-ins/python/api1</td>\n\
<td align=\"left\">devkit/plug-ins/python/api2</td>\n\
<td align=\"left\">devkit/applications/python</td>\n\
</tr>\n\
</table>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-examples\"></a><h3 id=\"new-examples\">New examples</h3></div>\n\
<ul>\n\
<li>The customComponentTagNode example has been added to demonstrate the new componentTag methods in MFnGeometryData</li>\n\
<li>The exampleFalloff example has been added to demonstrate the new MFallOffContext class in the OpenMayaAnim module.</li>\n\
<li>The basicMorphNode example has been added to demonstrate how to implement fan-in evaluation in custom GPU deformers.</li>\n\
<li>The simpleSkipNode example has been added to demonstrate the use of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MEvaluationNode::skipEvaluation()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_evaluation_node.html#aa8319e8d242c2a6bd5ecac159b665d02&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MEvaluationNode::skipEvaluation()</a></span>.</li>\n\
<li>The evaluationPruningEvaluator examples has been added to demonstrate the new <span class=\'code\'>MPxCustomEvaluator::wantPruneExecution</span> and <span class=\'code\'>MPxCustomEvaluator:pruneExecution</span> methods.</li>\n\
<li>The narrowPolyRenderOverride example has been added.</li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"updated-examples\"></a><h3 id=\"updated-examples\">Updated examples</h3></div>\n\
<p>The folllowing examples have been updated:</p>\n\
<ul>\n\
<li>offsetNode has been updated to demonstrate the use of <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MPxGPUDeformer::getFixedSetupData()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_px_g_p_u_deformer.html#a3eaede9f36e08ff2eb4cc508f06cf860&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MPxGPUDeformer::getFixedSetupData()</a></span>.</li>\n\
<li>The call to <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MThreadUtils::syncNumOpenMPThreads()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_thread_utils.html#ab857568ad1f4a49da93939d7db7c2a1c&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MThreadUtils::syncNumOpenMPThreads()</a></span> has been removed from threadingLockTests.</li>\n\
<li>The <span class=\'code\'>moveManip.py</span> example has been updated to have the same behavior as the C++ version.</li>\n\
<li>The <span class=\'code\'>pyBlindDoubleDataCmd.py</span> plug-in has been modified to fix a bug in the <span class=\'code\'>blindDoubleData</span> command.</li>\n\
<li>The glslShader example has been updated to no longer use the following deprecated classes: MGeometryPrimitive, MGeometryList, MGeometryLegacy, and MGeometryData.</li>\n\
<li>manipOverride has been updated.</li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"alembic-examples-updated-to-only-support-ogawa-alembic-files\"></a><h3 id=\"alembic-examples-updated-to-only-support-ogawa-alembic-files\">Alembic examples updated to only support Ogawa Alembic files</h3></div>\n\
<p>Maya no longer supports HDF5 variants of Alembic. Because of this, the following devkit examples now only support Ogawa Alembic files:</p>\n\
<ul>\n\
<li>gpuCache</li>\n\
<li>AbcBullet</li>\n\
<li>AbcImport</li>\n\
<li>AbcExport</li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"removed-examples\"></a><h3 id=\"removed-examples\">Removed examples</h3></div>\n\
<p>The following examples have been removed:</p>\n\
<ul>\n\
<li>exampleCameraSetView</li>\n\
<li>narrowPolyViewer</li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"scripting-changes\"></a><h2 id=\"scripting-changes\">Scripting changes</h2></div>\n\
<div class=\'section\'><a id=\"ufe-aware-commands\"></a><h3 id=\"ufe-aware-commands\">UFE-aware commands</h3></div>\n\
<p>Some commands now accept UFE path strings.</p>\n\
<p>Commands that are UFE-aware will have different syntax than non-UFE-aware commands.</p>\n\
The following is a list of UFE-aware commands. You are encouraged to look at the <a href=\'#!/url=./dev_help/What-s-New-What-s-Changed-/guid=Maya_SDK_Commands_index_html/\' title=\'\'>technical documentation</a> for these commands before using them: {{#style &quot;tablenobordernocolor&quot;}} | | | | | -- | -- | -- | |\n\
<ul>\n\
<li>\n\
createEditor\n\
</li>\n\
<li>\n\
delete\n\
</li>\n\
<li>\n\
duplicate\n\
</li>\n\
<li>\n\
group\n\
</li>\n\
<li>\n\
hide\n\
</li>\n\
<li>\n\
ls\n\
</li>\n\
</ul>\n\
|\n\
<ul>\n\
<li>\n\
move\n\
</li>\n\
<li>\n\
nameField\n\
</li>\n\
<li>\n\
nodeType\n\
</li>\n\
<li>\n\
outlinerEditor\n\
</li>\n\
<li>\n\
parent\n\
</li>\n\
<li>\n\
pickWalk\n\
</li>\n\
</ul>\n\
|\n\
<ul>\n\
<li>\n\
rename\n\
</li>\n\
<li>\n\
reorder\n\
</li>\n\
<li>\n\
rotate\n\
</li>\n\
<li>\n\
scale\n\
</li>\n\
<li>\n\
select\n\
</li>\n\
<li>\n\
showHidden\n\
</li>\n\
</ul>\n\
<p>|<br />{{/style}}</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-plug-ins\"></a><h3 id=\"new-plug-ins\">New plug-ins</h3></div>\n\
<ul>\n\
<li>convertToComponentTags.py plug-in: adds the <span class=\'code\'>convertToComponentTags</span> command to Maya</li>\n\
<li>snapTransform.py plug-in: adds the <span class=\'code\'>snapTransform</span> command to Maya</li>\n\
<li>gameVertexCount plug-in: adds the <span class=\'code\'>gameVertexCount</span> command to Maya</li>\n\
</ul>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-commands\"></a><h3 id=\"new-commands\">New commands</h3></div>\n\
<p>The <span class=\'code\'>FBXExtPlugin</span> command has been added to the fbxmaya plug-in. This command lets the user pass arguments to the FBX Extensions plug-in.</p>\n\
<p>The <span class=\'code\'>mimicManipulation</span> command has been added to Maya.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"new-flags-and-options\"></a><h3 id=\"new-flags-and-options\">New flags and options</h3></div>\n\
<p>The <span class=\'code\'>mergeBaseAnimLayer</span> (<span class=\'code\'>mbl</span>) and <span class=\'code\'>uiLoadConfiguration</span> (<span class=\'code\'>ulc</span>) options have been added to the <span class=\'code\'>file</span> command.</p>\n\
<p><span class=\'code\'>autoExpandAnimatedShapes</span> (<span class=\'code\'>xas</span>) flag has been added to the <span class=\'code\'>outlinerEditor</span> command.</p>\n\
<p><span class=\'code\'>noIntermediate</span> (<span class=\'code\'>ni</span>) flag has been added to the <span class=\'code\'>sets</span> command.</p>\n\
<p>The <span class=\'code\'>dumpInfo</span> (<span class=\'code\'>di</span>) option has been added to the <span class=\'code\'>deformerEvaluator</span> command. Executing <span class=\'code\'>deformerEvaluator -di</span> prints debug information about the deformer evaluator&#39;s clusters in JSON format.</p>\n\
<p>Two new options, <span class=\'code\'>startTime</span> (<span class=\'code\'>s</span>) and <span class=\'code\'>endTime</span> (<span class=\'code\'>e</span>), have been added to the <span class=\'code\'>filterCurve</span> command. These options specify the start time and end time, respectively, of the section to filter.</p>\n\
<p>Three new options, <span class=\'code\'>stash</span>, <span class=\'code\'>unstash</span>, and <span class=\'code\'>clearStash</span>, have been added to the <span class=\'code\'>optVar</span> command. These options let you backup and restore a variable.</p>\n\
<p>Several new options related to deformable chains have been added to the <span class=\'code\'>geometryAttrInfo</span> and <span class=\'code\'>deformableShape</span> commands.</p>\n\
<p>Several new options have been added to the <span class=\'code\'>ghosting</span> command to support the new ghosting editor workflows.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"changed-flags-and-options\"></a><h3 id=\"changed-flags-and-options\">Changed flags and options</h3></div>\n\
<p>The <span class=\'code\'>deformableShape</span> command&#39;s <span class=\'code\'>componentTagInjection</span> (<span class=\'code\'>cti</span>) option has been renamed <span class=\'code\'>tagInjectionList</span> (<span class=\'code\'>til</span>), and three new options, <span class=\'code\'>createUpstreamTagInjectionNode</span>, <span class=\'code\'>tagInjectionNode</span>, and <span class=\'code\'>upstreamTagInjectionNode</span> have been added.</p>\n\
<p>The <span class=\'code\'>name</span> flag has been removed from the <span class=\'code\'>deleteAttr</span>, <span class=\'code\'>affectedNet</span>, and <span class=\'code\'>dynExpression</span> commands.</p>\n\
<p>To specify all keys when using the cutKey Python command, use <span class=\'code\'>time=(None,None)</span> rather than <span class=\'code\'>time=()</span>.</p>\n\
<p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\'section\'><a id=\"removed-script\"></a><h3 id=\"removed-script\">Removed script</h3></div>\n\
<p>The <span class=\'code\'>performSkinCluster.mel</span> script has been removed. The equivalent functionality can be achieved using:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint lang-sh\">import maya.internal.nodes.skincluster.cmd_create as sk_create\n\
sk_create.Command().executeWithDefaults()\n\
</pre></div><p><a href=$12022-Whats-New-in-API.html#top\' title=\'\'>Back to top</a></p>\n\
<div class=\"metadata\"><h4>contextid</h4>\n\
<ul><li>WHATS_NEW_DEVHELP_CURRENT</li></ul></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";